#!/bin/ash
# Karl Godt Dec. 2013 for Puppy Linux Slacko
#set -x


check_for_acpid(){
test "`which acpid`" || { echo "Please install acpid package.";exit 1; }
[ -d /proc/acpi ] ||    { echo "No /proc/acpi . Exiting.";exit 1; }
 [ -d /etc/acpi ] ||    { echo "Please install acpi scripts package.";exit 1; }
test "`busybox modprobe -l | grep -qw button`" && {
[ "`lsmod | grep '^button'`" ] || { echo "Required button.ko kernel module not loaded.";exit 1; }
	}
}

start_acpid(){
acpid -l
sleep 2s
PIDOF_ACPID=`pidof acpid`
test -f /var/run/acpid.pid && read ACPID_PID </var/run/acpid.pid
test "$PIDOF_ACPID" && echo "Started acpid with pid '$PIDOF_ACPID' ."
test "$PIDOF_ACPID" = "$ACPID_PID" || echo "Warning: '$PIDOF_ACPID' is not same as in /var/run/acpid.pid ."	
acpi_listen &
}	

stop_acpid(){
 test "`pidof acpid`" && { 
 killall acpid && echo "Stopped acpid." || echo "Failed to stop acpid."
 } || echo "acpid is not running."
 test "`pidof acpi_listen`" && { 
 killall acpi_listen && echo "Stopped acpid_listen." || echo "Failed to stop acpid_listen."
 } || echo "acpid_listen is not running."
}

case $1 in 
start|run|up|on)
	check_for_acpid
	test "$DISPLAY" || export DISPLAY=':0'
	start_acpid
;;
stop|kill|down|off)
	stop_acpid
;;
restart|reload|rerun)
	stop_acpid
	sleep 2s
	check_for_acpid
	test "$DISPLAY" || export DISPLAY=':0'
	start_acpid
;;
*)
	echo "$0: Unhandled option '$1' ."
echo "Use 'start|run|up|on' || 'stop|kill|down|off' || 'restart|reload|rerun' ."
	exit 1
;;
esac
exit $?